unit MainCtrl;

interface
var
  MainHWND : Integer;

implementation
uses
  ShellAPI,
  Messages,
  Windows,
  Window,
  SysUtils;

var
  wClass: TWndClassA; { main window class }
  AlreadyRun: Boolean;
  LastWindow: Integer;

const
  szClassName = 'VSniffer';

begin
  {check if app is running}
  LastWindow := FindWindow(szClassName, nil);
  AlreadyRun := LastWindow <> 0;

  if LowerCase(ParamStr(1)) = 'status' then
  begin
    if AlreadyRun then
      MessageBox(LastWindow, PChar('Running...'), PChar('Status'), MB_OK)
    else
    begin
      MessageBox(LastWindow, PChar('Stopped'), PChar('Status'), MB_OK);
      Halt;
    end;
  end;

  if AlreadyRun then
  begin
    if (LowerCase(ParamStr(1)) = 'close') or (LowerCase(ParamStr(1)) = 'stop') then
    begin
      PostMessage(LastWindow, WM_DESTROY, 0, 0);
      Halt;
    end
    else if LowerCase(ParamStr(1)) = 'restart' then
    begin
      PostMessage(LastWindow, WM_DESTROY, 0, 0);
    end
    else if LowerCase(ParamStr(1)) <> 'start' then
      Halt;
  end;

  { main window class }
  with wClass do
  begin
    lpszClassName := szClassName;
    lpfnWndProc := @WndProc;
  end;
  wClass.hInstance := hInstance;
  RegisterClass(wClass);

  { create invisible(fake) main window }
  MainHWND := CreateWindow(szClassName, ' ', 0, 0, 0, 0, 0, 0, 0, hInstance, nil);

  { create popup menu for tray bar icon }
  {hPopupMenu := CreatePopupMenu;
  InsertMenu(hPopupMenu, MF_BYPOSITION, MF_BYPOSITION, hPopAbout, PChar('&About'));
  AppendMenu(hPopupMenu, MF_BYPOSITION, hPopOpt, PChar('Opti&ons'));
  AppendMenu(hPopupMenu, MF_BYPOSITION, hPopExit, PChar('E&xit'));

  { raise error on dual program running }
  {if AlreadyRun then
    begin
      MessageBox(MainHWND, 'Program is already running!', 'Error!', MB_ICONERROR);
      SendMessage(MainHWND, WM_DESTROY, 0, 0);
    end;

  { create tray bar icon }
  {with _IconData do
  begin
    cbSize := SizeOf(_IconData);
    wnd := MainHWND;
    uCallbackMessage := WM_CALLBACK_MESSAGE;
    szTip := 'Fast Control';
    hIcon := LoadImage(hInstance, 'TRAYICON', IMAGE_ICON, 16, 16, 0);
    uFlags := NIF_MESSAGE or NIF_ICON or NIF_TIP;
  end;
  Shell_NotifyIcon(NIM_ADD, @_IconData);}
end.

